<template>
  <v-flex xs12 sm6>
    <v-card>
      <v-card-title primary-title>
        <div>
          <h3 class="headline mb-0">Countrate</h3>
        </div>
      </v-card-title>
      <v-responsive>
        <div ref="plot" ></div>
      </v-responsive>
      <!-- <v-card-actions>
        <v-btn flat color="orange">Share</v-btn>
        <v-btn flat color="orange">Explore</v-btn>
      </v-card-actions> -->
    </v-card>
  </v-flex>
</template>

<script>
const axios = require('axios')
import Plotly from 'plotly.js-dist'
import plotly_layout from '~/assets/plotly_layout.json'

export default {
  name: 'Countrate',
  data() {
    return {
      info: null,
      timer: '',
      count: 0,
      create: true
    }
  },
  methods: {
    load_countrate() {
      function range(i) {
        return i ? range(i - 1).concat(i) : []
      }

      var config = {
        headers: {
          'Content-Type': 'application/json',
          'Cache-Control': 'no-cache'
        }
      }
      axios
        .get('/data/count.json')
        .then(response => (this.info = response), config)
    },
    init_countrate_plot() {
      var _countrate = this.info.data.countrate.channel_0
      var time = new Date()

      var data = [
        {
          x: [time],
          y: [_countrate],
          mode: 'lines',
          line: { color: '#80CAF6' }
        }
      ]

      let layout = {
        ...plotly_layout,
        ...{}
      }

      Plotly.plot(this.$refs.plot, data, layout)
    },
    update_countrate_plot() {
      var _countrate = this.info.data.countrate.channel_0
      var time = new Date()

      var update = {
        x: [[time]],
        y: [[_countrate]]
      }

      var olderTime = time.setMinutes(time.getMinutes() - this.timer)
      var futureTime = time.setMinutes(time.getMinutes() + this.timer)

      var minuteView = {
        xaxis: {
          type: 'date',
          range: [olderTime, futureTime]
        }
      }

      Plotly.relayout(this.$refs.plot, minuteView)
      Plotly.extendTraces(this.$refs.plot, update, [0])
      this.count += 1
      if (this.count === 100) clearInterval(this.timer)
    }
  },
  created() {
    this.load_countrate()
    this.timer = setInterval(this.load_countrate, 1000)
  },

  mounted() {
    this.$watch('info', function(newVal, oldVal) {
      if (this.create) {
        this.init_countrate_plot()
        this.create = false
      } else {
        this.update_countrate_plot()
      }
    })
  },
  beforeDestroy() {
    clearInterval(this.timer)
  }
}
</script>
